/*********
  Rui Santos
  Complete project details at http://randomnerdtutorials.com  
*********/

// Load Wi-Fi library
#include <WiFi.h>

// Replace with your network credentials
const char* ssid     = "moore8_tech";
const char* password = "moore8tech=2018";

// Set web server port number to 80
WiFiServer server(80);

// Variable to store the HTTP request
String header;

// Auxiliar variables to store the current output state
String Forward = "off";
String Backward = "off";
String Left = "off";
String Right = "off";
String Obstacle_mode = "off";

// Assign output variables to GPIO pins
/*const int output26 = 26;
const int output27 = 27;
const int output24 = 24;
const int output25 = 25;*/

void setup() {
  Serial.begin(115200);
  // Initialize the output variables as outputs
  /*pinMode(output26, OUTPUT);
  pinMode(output27, OUTPUT);
  pinMode(output24, OUTPUT);
  pinMode(output25, OUTPUT);
  // Set outputs to LOW
  digitalWrite(output26, LOW);
  digitalWrite(output27, LOW);
  digitalWrite(output24, LOW);
  digitalWrite(output25, LOW);*/

  // Connect to Wi-Fi network with SSID and password
  Serial.print("Connecting to ");
  Serial.println(ssid);
  WiFi.begin(ssid, password);
  while (WiFi.status() != WL_CONNECTED) {
    delay(500);
    Serial.print(".");
  }
  // Print local IP address and start web server
  Serial.println("");
  Serial.println("WiFi connected.");
  Serial.println("IP address: ");
  Serial.println(WiFi.localIP());
  server.begin();
}

void loop(){
  WiFiClient client = server.available();   // Listen for incoming clients

  if (client) {                             // If a new client connects,
    Serial.println("New Client.");          // print a message out in the serial port
    String currentLine = "";                // make a String to hold incoming data from the client
    while (client.connected()) {            // loop while the client's connected
      if (client.available()) {             // if there's bytes to read from the client,
        char c = client.read();             // read a byte, then
        Serial.write(c);                    // print it out the serial monitor
        header += c;
        if (c == '\n') {                    // if the byte is a newline character
          // if the current line is blank, you got two newline characters in a row.
          // that's the end of the client HTTP request, so send a response:
          if (currentLine.length() == 0) {
            // HTTP headers always start with a response code (e.g. HTTP/1.1 200 OK)
            // and a content-type so the client knows what's coming, then a blank line:
            client.println("HTTP/1.1 200 OK");
            client.println("Content-type:text/html");
            client.println("Connection: close");
            client.println();
            
            // turns the GPIOs on and off
            if (header.indexOf("GET /26/on") >= 0) {
              Serial.println("W");//Forward on
              Forward = "on";
              //digitalWrite(output26, HIGH);
            } else if (header.indexOf("GET /26/off") >= 0) {
              Serial.println("I"); //Forward off
              Forward = "off";
              //digitalWrite(output26, LOW);
            } else if (header.indexOf("GET /27/on") >= 0) {
              Serial.println("S"); //Backward on
              Backward = "on";
             // digitalWrite(output27, HIGH);
            } else if (header.indexOf("GET /27/off") >= 0) {
              Serial.println("K"); //Backward off
              Backward = "off";
              //digitalWrite(output27, LOW);
            }
      //new added
      else if (header.indexOf("GET /24/on") >= 0) {
              Serial.println("A"); //Left on 
              Left = "on";
        //digitalWrite(output24,HIGH);
      }
      else if (header.indexOf("GET /24/off") >= 0) {
              Serial.println("J"); //Left off
              Left = "off";
              //digitalWrite(output24, LOW);
      }
      else if (header.indexOf("GET /25/on") >= 0) {
              Serial.println("D"); //Right on
              Right = "on";
              //digitalWrite(output25, HIGH);
            } else if (header.indexOf("GET /25/off") >= 0) {
              Serial.println("L"); //Right off
              Right = "off";
              //digitalWrite(output25, LOW);
            }
        else if (header.indexOf("GET /23/on") >= 0) {
              Serial.println("B"); //Obstacle_mode on
              Obstacle_mode = "on";
              //digitalWrite(output25, HIGH);
            } else if (header.indexOf("GET /23/off") >= 0) {
              Serial.println("N"); //Obstacle_mode off
              Obstacle_mode = "off";
              //digitalWrite(output25, LOW);
            }
            
            // Display the HTML web page
            client.println("<!DOCTYPE html><html>");
            client.println("<head><meta name=\"viewport\" content=\"width=device-width, initial-scale=1\">");
            client.println("<link rel=\"icon\" href=\"data:,\">");
            // CSS to style the on/off buttons 
            // Feel free to change the background-color and font-size attributes to fit your preferences
            client.println("<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}");
            client.println(".button { background-color: #4CAF50; border: none; color: white; padding: 16px 40px;");
            client.println("text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;}");
            client.println(".button2 {background-color: #555555;}</style></head>");
      
            /* client.println("<style>html { font-family: Helvetica; display: inline-block; margin: 0px auto; text-align: center;}");
            client.println(".button3 { background-color: #4CAF50; border: none; color: white; padding: 16px 40px;");
            client.println("text-decoration: none; font-size: 30px; margin: 2px; cursor: pointer;}");
            client.println(".button4 {background-color: #555555;}</style></head>");*/
            
      
      
      
            // Web Page Heading
            client.println("<body><h1>ESP32 Web Server</h1>");
            
            // Display current state, and ON/OFF buttons for GPIO 26  
            client.println("<p>Forward " + Forward + "</p>");
            // If the Forward is off, it displays the ON button       
            if (Forward=="off") {
              client.println("<p><a href=\"/26/on\"><button class=\"button\">ON</button></a></p>");
            } else {
              client.println("<p><a href=\"/26/off\"><button class=\"button button2\">OFF</button></a></p>");
            } 
               
            // Display current state, and ON/OFF buttons for GPIO 27  
            client.println("<p>Backward - State " + Backward + "</p>");
            // If the Backward is off, it displays the ON button       
            if (Backward=="off") {
              client.println("<p><a href=\"/27/on\"><button class=\"button\">ON</button></a></p>");
            } else {
              client.println("<p><a href=\"/27/off\"><button class=\"button button2\">OFF</button></a></p>");
            }
      
      // Display current state, and ON/OFF buttons for GPIO 24  
            client.println("<p>Right - State " + Left + "</p>");
            // If the Left is off, it displays the ON button  
            if (Left=="off") {
              client.println("<p><a href=\"/24/on\"><button class=\"button\">ON</button></a></p>");
            } else {
              client.println("<p><a href=\"/24/off\"><button class=\"button button2\">OFF</button></a></p>");
            } 
               
            // Display current state, and ON/OFF buttons for GPIO 25  
            client.println("<p>Left - State " + Right + "</p>");
            // If the Right is off, it displays the ON button       
            if (Right=="off") {
              client.println("<p><a href=\"/25/on\"><button class=\"button\">ON</button></a></p>");
            } else {
              client.println("<p><a href=\"/25/off\"><button class=\"button button2\">OFF</button></a></p>");
            }

            // Display current state, and ON/OFF buttons for GPIO 25  
            client.println("<p> Obstacle_mode - State " + Right + "</p>");
            // If the Right is off, it displays the ON button       
            if (Obstacle_mode=="off") {
              client.println("<p><a href=\"/23/on\"><button class=\"button\">ON</button></a></p>");
            } else {
              client.println("<p><a href=\"/23/off\"><button class=\"button button2\">OFF</button></a></p>");
            }
      
    
            client.println("</body></html>");
            
            // The HTTP response ends with another blank line
            client.println();
            // Break out of the while loop
            break;
          } else { // if you got a newline, then clear currentLine
            currentLine = "";
          }
        } else if (c != '\r') {  // if you got anything else but a carriage return character,
          currentLine += c;      // add it to the end of the currentLine
        }
      }
    }
    // Clear the header variable
    header = "";
    // Close the connection
    client.stop();
    Serial.println("Client disconnected.");
    Serial.println("");
  }
}
